SystemOrganization addCategory: #'GT-Setup'!

Object subclass: #GTImageSetupCommandLineHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Setup'!

!GTImageSetupCommandLineHandler commentStamp: 'TudorGirba 3/19/2014 12:07' prior: 0!
The command that can be triggered to setup a image right after the GToolkit configuration is loaded in a fresh Pharo image.

Example usage in a Jenkins:
./pharo $JOB_NAME.image gtimagesetup!

!GTImageSetupCommandLineHandler class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 3/19/2014 11:44'!
commandName
	^ 'gtimagesetup'! !

!GTImageSetupCommandLineHandler class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 3/19/2014 11:45'!
description
	^ 'Sets up the image with GToolkit specific tools and settings'! !

!GTImageSetupCommandLineHandler methodsFor: 'activation' stamp: 'TudorGirba 3/19/2014 12:05'!
activate
	self cleanupWorld.
	self installGLMWhitespaceTheme.
	self installFonts.
	self installAthens.
	self installGTInspector.
	self installGTDebuggers.
	self installGTPlayground.
	self flushMCCache.
	self setPreferredSettings.
	
	Smalltalk snapshot: true andQuit: true.
! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
cleanupWorld
	World backgroundMorph: nil.
	World color: Color white.
	World submorphs
		do: [ :each | 
			(each isKindOf: ImageMorph)
				ifTrue: [ each delete ] ].
	StandardWindow allSubInstancesDo: #delete.
	SystemWindow allInstancesDo: #delete! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
flushMCCache
	MCFileBasedRepository flushAllCaches ! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 12:04'!
installAthens
	ROPlatform setCurrent: 'athens'! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
installFonts
	self loadFonts.
	StandardFonts 
		setAllStandardFontsTo: (LogicalFont familyName: 'Source Sans Pro' pointSize: 10);
		haloFont: (LogicalFont familyName: 'Source Sans Pro' pointSize: 10);
		windowTitleFont: (LogicalFont familyName: 'Source Sans Pro' pointSize: 14);
		balloonFont: (LogicalFont familyName: 'Source Sans Pro' pointSize: 10);
		codeFont: (LogicalFont familyName: 'Source Code Pro' pointSize: 10)! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
installGLMWhitespaceTheme
	GLMWhitespaceTheme 
		defaultSettings: nil;
		setPreferredWorldBackground;
		beCurrent! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
installGTDebuggers
	
	GTGenericStackDebugger registerToolsOn: Smalltalk tools.
	
	GTGenericStackDebugger registerExtraToolsOn: Smalltalk tools.
	GTPPDebugger registerToolsOn: Smalltalk tools.
	GTGlamourDebugger registerToolsOn: Smalltalk tools.
	ACGlamourDebugger registerToolsOn: Smalltalk tools.
	GTSUnitDebugger registerToolsOn: Smalltalk tools.
	
	GTMoldableDebugger enableDebuggerWindowDistinctColor: true! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
installGTInspector
	GTInspector registerToolsOn: Smalltalk tools ! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 11:45'!
installGTPlayground
	
	GTPlayground registerToolsOn: Smalltalk tools! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 12:04'!
loadFonts
	#('SourceCodeProRegular' 'SourceCodeProBold' 'SourceSansProRegular' 'SourceSansProBold') do: [ :each | 
		each asSymbol asClassIfAbsent: [
			Gofer new 
				smalltalkhubUser: 'girba' project: 'FreeFonts';
				package: each;
				load ].
		(Smalltalk at: each asSymbol) new install ].
	FreeTypeSystemSettings loadFt2Library: true.
	FreeTypeFontProvider current updateFromSystem! !

!GTImageSetupCommandLineHandler methodsFor: 'moose utilities' stamp: 'TudorGirba 3/19/2014 12:05'!
setPreferredSettings
	NECPreferences popupShowAutomatic: false! !
